#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <time.h>
#include <windows.h>

void DummyDataInitialization (double* pMatrix, double* pVector, int Size) {
  int i, j;  

  for (i=0; i<Size; i++) {
    pVector[i] = 1;
    for (j=0; j<Size; j++)
      pMatrix[i*Size+j] = i;
  }
}

void RandomDataInitialization(double* pMatrix, double* pVector, int Size) {
  int i, j; 
  srand(unsigned(clock()));
  for (i=0; i<Size; i++) {
    pVector[i] = rand()/double(1000);
    for (j=0; j<Size; j++)
      pMatrix[i*Size+j] = rand()/double(1000);
  }
}

void ProcessInitialization (double* &pMatrix, double* &pVector, 
    double* &pResult, int &Size) {
    printf("\nEnter size of the initial objects: ");
    scanf("%d", &Size);
    
  pMatrix = new double [Size*Size];
  pVector = new double [Size];
  pResult = new double [Size];
  RandomDataInitialization(pMatrix, pVector, Size);
}

void PrintMatrix (double* pMatrix, int RowCount, int ColCount) {
  int i, j; 
  for (i=0; i<RowCount; i++) {
    for (j=0; j<ColCount; j++)
	  printf("%7.4f ", pMatrix[i*RowCount+j]);
	printf("\n");
  }
}

void PrintVector (double* pVector, int Size) {
  int i;
  for (i=0; i<Size; i++)
    printf("%7.4f ", pVector[i]);
}

void ResultCalculation(double* pMatrix, double* pVector, double* pResult,
  int Size) {
  int i, j; 
  for (i=0; i<Size; i++) {
    pResult[i] = 0;
	for (j=0; j<Size; j++)
	  pResult[i] += pMatrix[i*Size+j]*pVector[j];
  }
}

void ProcessTermination(double* pMatrix,double* pVector,double* pResult) {
  delete [] pMatrix;
  delete [] pVector;
  delete [] pResult;
}

void main()
{
  double* pMatrix;  
  double* pVector; 
  double* pResult;   
  int Size;		    
  double start, finish;
  double duration;
  printf("\nSerial matrix-vector multiplication program\n");
  ProcessInitialization(pMatrix, pVector, pResult, Size);

  printf ("\nInitial Matrix: \n"); 
  PrintMatrix(pMatrix, Size, Size);
  printf("\nInitial Vector: \n");
  PrintVector(pVector, Size);

  start = GetTickCount();
  ResultCalculation(pMatrix, pVector, pResult, Size);
  finish = GetTickCount();
  duration = (finish-start)*1000;
  printf ("\n Result Vector: \n");
  PrintVector(pResult, Size);
  printf ("\n Time: \n");
  printf("%10.5f ",duration);
  ProcessTermination(pMatrix, pVector, pResult);
  getch();
  }
